myapp/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('', views.index, name='index'),
    path('home', views.home, name='home'),
    path('base', views.base, name='base'),
    path('item/<int:id>', views.item_by_id, name='item_by_id'),
    path('itemlist/<int:list_id>', views.itemlist, name='itemlist'),
    path('create/', views.create, name='create'),
    path('create/itemlist/<int:list_id>', views.itemlist, name='itemlist'),
]

mysite/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include('myapp.urls')),
    path('app/', include('myapp.urls')),
    path('admin/', admin.site.urls),
]

myapp/models.py
from django.db import models
from django.forms import model_to_dict
from django.utils.timezone import now

class Item(models.Model):
    title = models.CharField(max_length=200)  # Short description of the item
    datetime_found = models.DateTimeField(default=now, blank=True)  # Date and time of when the item was found


def items():
    res = []
    for i in Item.objects.all():
        res.append(model_to_dict(i))
    return res


class ToDoList(models.Model):
    name = models.CharField(max_length=200)

    def __str__(self):
        return self.name

    def __int__(self):
        return self.id


class ListItem(models.Model):
    todolist = models.ForeignKey(ToDoList, on_delete=models.CASCADE)  # related to ToDoList
    text = models.CharField(max_length=300)
    complete = models.BooleanField()  # Boolean says if we're completed list item

    def __str__(self):
        return self.text

myapp/forms.py
from django import forms


class CreateNewList(forms.Form):
    name = forms.CharField(label="Name", max_length=200)  # Label is the text that shows before the input-box
    check = forms.BooleanField()  # Boolean check button

myapp/views.py
from django.shortcuts import render
from django.http import HttpResponse, HttpResponseRedirect
from .models import Item, ToDoList
from .forms import CreateNewList
# Create your views here.


def index(response):
    return HttpResponse("<h1>Hello, world!</h1>")


def item_by_id(id):
    item = Item.objects.get(pk=id)
    return HttpResponse(f"Item: {item.title}, published on {item.datetime_found}")


def home(response):
    return render(response, "myapp/home.html", {})


def base(response):
    return render(response, "myapp/base.html", {})


def itemlist(response, list_id):
    ls = ToDoList.objects.get(id=list_id)
    return render(response, "myapp/itemlist.html", {"ls": ls})


def create(response):
    global t
    if response.method == "POST":
        form = CreateNewList(response.POST)  # Takes POST and uses data for form
        if form.is_valid():  # is_valid() checks class-fields for valid input
            n = form.cleaned_data["name"]  # Clean and un-enc data, specify field "name"
            t = ToDoList(name=n)  # Use data to create new ToDoList
            t.save()
        return HttpResponseRedirect("itemlist/%i" % t.id)  # Redirect to page that shows the list
    else:
        form = CreateNewList()
    return render(response, "myapp/create.html", {"form": form})

myapp/templates/myapp/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>{% block title %}Mampenda's Webite{% endblock %}</title>
</head>
<body>
    <div id="content", name="content">
        {% block content %}
        <h1>Welcome to Mampenda's website!</h1>
        {% endblock %}
    </div>
</body>
</html>

myapp/templates/myapp/create.html
{% extends "myapp/base.html" %}
{% block title %} Create new List of Items {% endblock %}
{% block content %}
Create Page
<form method="POST" action="/create/">
    {% csrf_token %}
    {{form.as_p}}
    <button type="submit", name="save">Create New</button>
</form>
{% endblock %}

myapp/templates/myapp/home.html
{% extends "myapp/base.html" %}

{% block title %}
Home
{% endblock %}

{% block content %}
<h1>Home Page</h1>
{% endblock %}

myapp/templates/myapp/itemlist.html
{% extends "myapp/base.html" %}
{% block title %}View List of Items{% endblock %}

{% block content %}
    <h1>{{ls.name}}</h1>
    <ul>
        {% for i in ls.listitem_set.all %}
            {% if i.complete == TRUE %}
                <li>{{i.text}} - COMPLETE</li>
            {% else %}
                <li>{{i.text}} - INCOMPLETE</li>
            {% endif %}
        {% endfor %}
    </ul>
{% endblock %}